__precompile__()

module DiffEqSensitivity

using DiffEqBase, ForwardDiff, Flux, DiffEqDiffTools, Statistics
using DiffEqCallbacks, QuadGK, RecursiveArrayTools, LinearAlgebra
using DataFrames, GLM, RecursiveArrayTools
using Parameters: @unpack


abstract type SensitivityFunction end
abstract type GSAMethod end
struct Sobol <: GSAMethod end
struct Morris <: GSAMethod end

include("derivative_wrappers.jl")
include("local_sensitivity.jl")
include("adjoint_sensitivity.jl")
include("morris_sensitivity.jl")
include("sobol_sensitivity.jl")
include("regression_sensitivity.jl")
include("DGSM.jl")

export extract_local_sensitivities

export ODELocalSensitivityFunction, ODELocalSensitivityProblem, SensitivityFunction,
       ODEAdjointSensitivityProblem, ODEAdjointProblem, AdjointSensitivityIntegrand,
       adjoint_sensitivities, adjoint_sensitivities_u0, Sobol, Morris, gsa,
       SensitivityAlg, regression_sensitivity, DGSM


end # module
